"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ProxyAgent = void 0;
const form_data_1 = __importDefault(require("form-data"));
const fs_1 = require("fs");
const node_toolkit_1 = require("@tech_query/node-toolkit");
function buildData({ method, request: { type, body, files = {} } }) {
    if (/^Head|Get|Delete$/.test(method))
        return '';
    if (type !== 'multipart/form-data')
        return body;
    const form = new form_data_1.default();
    for (const key in body)
        form.append(key, body[key]);
    for (const [key, data] of Object.entries(files)) {
        const files = data instanceof Array ? data : [data];
        for (const { filepath, originalFilename } of files)
            form.append(key, (0, fs_1.createReadStream)(filepath), originalFilename);
    }
    return form;
}
async function pipe(URL, context) {
    const _a = context.header, { host } = _a, headers = __rest(_a, ["host"]);
    const response = await (0, node_toolkit_1.request)(URL, context.method, headers, buildData(context));
    (context.status = response.statusCode),
        (context.message = response.statusMessage);
    for (const key in response.headers)
        if (key !== 'status')
            context.set(key.replace(/^\w|-\w/g, char => char.toUpperCase()), response.headers[key]);
    return (context.body = response);
}
function ProxyAgent(proxyMap) {
    return async function (context, next) {
        const URL = context.path + context.request.search;
        for (const path in proxyMap) {
            const final = URL.replace(proxyMap[path], path);
            if (final !== URL)
                return pipe(final, context);
        }
        await next();
    };
}
exports.ProxyAgent = ProxyAgent;
